/*
 * @(#)UNIXUser.c	1.5 97/09/09
 * 
 * Copyright (c) 1995-1997 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.0
 */

#include	<crypt.h>
#include	<pwd.h>
#include	<string.h>

#include	"com_sun_server_realm_unix_UNIXUser.h"

void
com_sun_server_realm_unix_UNIXUser_loadFromPasswd (
    struct Hcom_sun_server_realm_unix_UNIXUser	*this
)
{
    char		*logname;
    struct passwd	value;
    char		buf [BUFSIZ];

    logname = makeCString (unhand (this)->user);
    if (getpwnam_r (logname, &value, buf, sizeof buf) == 0) {
	/*
	 * setting homedir or passwd to null indicates an error,
	 * and the caller throws an exception
	 */
	unhand (this)->homedir = 0;
	unhand (this)->passwd = 0;

    } else {
	unhand (this)->homedir = makeJavaString (value.pw_dir,
				    strlen (value.pw_dir));
	unhand (this)->passwd = makeJavaString (value.pw_passwd,
				    strlen (value.pw_passwd));

	/*
	 * NOTE:  this doesn't do "shadow password" lookups.
	 * Some sites hide their "real" password data.
	 */
    }
}

long
com_sun_server_realm_unix_UNIXUser_checkCrypt (
    struct Hcom_sun_server_realm_unix_UNIXUser	*this,
    struct Hjava_lang_String		*password
)
{
    char				*plaintext;
    char				*ciphertext;
    char				*computed;

    plaintext = makeCString (password);
    ciphertext = makeCString (unhand (this)->passwd);
    computed = crypt (plaintext, ciphertext);

    /*
    free (plaintext);
    free (ciphertext);
    */

    return strcmp (computed, ciphertext) == 0;


    /*
     * NOTE:  this doesn't look up the passphrase again; in some
     * environments, caching at this level may be undesirable.
     *
     * To avoid the caching, look it up ... and if the users's
     * been deleted, return some value like "-1" (not zero or one).
     */
}

